function [dst ] = poissonBlend( mask,inIm,dst,dstCropColor,anchor)
 %labels,source,target,targetPatch 

inIm=double(inIm);
 mask=double(mask);
 
 dstCropColor=double(dstCropColor);
[mH mW] =size(mask);
 
 out =double(zeros(mH,mW));
 outColor=double(zeros(mH,mW,3));
 
 nhood=[0 1 0;
        1 1 1;
        0 1 0;];
    
    maskEroded=imerode(mask,nhood);
 
    index=find(maskEroded>0);
    [n1 w]=size(index);   
    
    boundary=mask-maskEroded;
    bndyIndex=find(boundary>0);
    [n2 w]=size(bndyIndex);
 
    indexMask=find(mask>0);
    keySet=indexMask;
    valueSet=1:n1+n2;
    map = containers.Map(keySet,valueSet);
    
   for k=1:3
       
              p = [];% y direction
        q = [];% x
        s = [];
       
       dstCrop=dstCropColor(:,:,k);
       src=inIm(:,:,k);
     A = sparse ( p, q, s, n1+n2,n1+n2);
     b=zeros(n1+n2,1);
     
     for i=1:n1
         
     e=i;
       A(e, map(index(i)))=4; 
    A(e,  map(index(i)-mH))=-1;
    
    A(e,  map(index(i)+mH))=-1;
    A(e, map( index(i)-1))=-1;
    A(e, map( index(i)+1))=-1;
    
    b(e) =4*src(index(i))-src(index(i)-mH)-src(index(i)+mH)-src(index(i)-1)-src(index(i)+1) ;
    
      
     end
    
     
     for i=1:n2
         e=e+1;
         A(e, map( bndyIndex(i)))=4;
         
                 if (mask(bndyIndex(i)+mH)==1)
                      A(e,  map(bndyIndex(i)+mH))=-1;
                      b(e) =b(e)+ src(bndyIndex(i))-src(bndyIndex(i)+mH);

                 else
                      b(e) =b(e)+ dstCrop(bndyIndex(i)+mH)+ src(bndyIndex(i))-src(bndyIndex(i)+mH);
              
                 end
              %%
              if (mask(bndyIndex(i)-mH)==1)
                      A(e,  map(bndyIndex(i)-mH))=-1;
                      b(e) =b(e)+ src(bndyIndex(i))-src(bndyIndex(i)-mH);

                 else
                      b(e) =b(e)+ dstCrop(bndyIndex(i)-mH)+ src(bndyIndex(i))-src(bndyIndex(i)-mH); 
              
                 end
         %%
         
         if (mask(bndyIndex(i)+1)==1)
                      A(e,  map(bndyIndex(i)+1))=-1;
                      b(e) =b(e)+ src(bndyIndex(i))-src(bndyIndex(i)+1);

                 else
                      b(e) =b(e)+ dstCrop(bndyIndex(i)+1)+ src(bndyIndex(i))-src(bndyIndex(i)+1);
              
                 end
              
               %%
           
         if (mask(bndyIndex(i)-1)==1)
                      A(e,  map(bndyIndex(i)-1))=-1;
                      b(e) =b(e)+ src(bndyIndex(i))-src(bndyIndex(i)-1);

                 else
                      b(e) =b(e)+ dstCrop(bndyIndex(i)-1)+ src(bndyIndex(i))-src(bndyIndex(i)-1);
              
                 end
              
             
     end
         
   
     V=lscov(A,b);
    for y=1: size(indexMask,1)
    out(indexMask(y))=V(y);
    end
    
    outColor(:,:,k)=out;
    clear A
    clear b
   end
   
  for j=1:mW
  for i=1:mH
      if(mask(i,j)~=0)
   dst(anchor(1)+i-1 ,anchor(2)+j-1,:)=outColor(i,j,:);
      end
  end
  end
   
    

end

